#include <nds.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "ano_sound.h"
//FC C# D D# E F F# G G# A (A# B or B H)
//KFh~t@\V (do re mi fa so ra si)
// ړh@C != do
// Œh@C == do
//http://www.gabacho-net.jp/whims/whim0010.html
//http://www.yk.rim.or.jp/~kamide/music/notes.html
//ϗKỉ(2^(1/12)) =1.059463094= pow(2.0,1.0/12.0) )

#define DEF_FREQ_NUM	29	// RIN^[u{Txiapj

const double equalChangeTable[] = {
	1.0/pow(2.0,9.0/12.0)	*8.0,
	1.0/pow(2.0,7.0/12.0)	*8.0,
	1.0/pow(2.0,5.0/12.0)	*8.0,
	1.0/pow(2.0,4.0/12.0)	*8.0,
	1.0/pow(2.0,2.0/12.0)	*8.0,
	1.0	*8.0,
	pow(2.0,2.0/12.0)	*8.0
} ;
const double equalChangeTable_S[] = {
	1.0/pow(2.0,8.0/12.0)	*8.0,
	1.0/pow(2.0,6.0/12.0)	*8.0,
	1.0/pow(2.0,4.0/12.0)	*8.0,
	1.0/pow(2.0,3.0/12.0)	*8.0,
	1.0/pow(2.0,2.0/12.0)	*8.0,
	pow(2.0,1.0/12.0)	*8.0,
	pow(2.0,3.0/12.0)	*8.0
} ;
int *workFreq_n ;
int *workFreq_s ;
//ϗequal temperament
//just temperament scale:Kmajor scale
//IN^[uFSܓxFSlxFOxFZOxFZxFZZx
//  1:2         2:3        3:4     4:5     5:6      3:5     5:8
//		4:5:6iOaj
//		1/6:1/5:1/4iZOaj
//		iOaj
//		iOaj
//		̘aEZEZEEEZE
//		Z̘aZEEEZEEE
//                        x1.067 x1.200        x1.406 x1.600  x1.800
//K mejor x1.000	x1.125 x1.250 x1.333 x1.500 x1.667 x1.875 x2
//ZK minor x1.000	x1.125 x1.200 x1.333 x1.500 x1.600 x1.800 x2
//̒ZKRZKEaZKEIZK@̂Rނ
//just temperament scale:ZKnatural major scale/harmonic minor scale/melodic minor scale
// harmnic minor scale : natural sol(1.800) -> sol#(x1.875)
// melodic minor scale : natural fa (1.600) -> fa #(x1.667)
// melodic minor scale : natural sol(1.800) -> sol#(x1.875)
const float mejorChangeTable[] = {
//		,,,4/5, ,1,,6/5, ,6/5*5/4, ,6/5*3/2,2,6/5*3/2*5/4,,6/5*3/2*3/2
//		AƁc
//		6.0/5.0 / 2.0,
//		6.0/5.0 * 3.0/2.0 * 3.0/2.0 / 4.0,
//		6.0/5.0 * 5.0/4.0 / 2.0,
//		4.0/5.0,
//		6.0/5.0 * 3.0/2.0 / 2.0,
//		1.0,
//		6.0/5.0 * 3.0/2.0 * 5.0/4.0 / 2.0
//		
//		3.0/5.0, 27.0/40.0,3.0/4.0,4.0/5.0,9.0/10.0,1.0,9.0/8.0
//
//		cƁc
		1.0, 9.0/8.0,5.0/4.0,4.0/3.0,3.0/2.0,5.0/3.0,15.0/8.0
};
//		4:5:6iOaj甼l
//		C#:F:G#=F*4/5:4/3:F*6/5 
//		D#:G:A#=G*4/5:3/2:G*6/5 
//		F#=...D̒OxH = 9/8*5/4 = 1.40625 ?
const float mejorChangeTable_S[] = {
		16.0/15.0, 6.0/5.0, 4.0/3.0, 45.0/32.0,8.0/5.0,9.0/5.0,2.0
} ;
//	Z@CɌvZĂe[u
//	iRZK   C D E F G A Bj <- 
//	iaZK   C D E F G#A Bj
//	iIZK C D E F#G#A Bj
//	CŎw肳Ă̕ϊe[uʂ̂
//	ʏCɐFtĂ邯A}Ci[iCZj
//	C^[tF[XlȂƁc
//	nƃCZsȂŉʏׂc
//	̃e[uRZKŏƒaZKŘaoȂB
const float minorChangeTable[] = {
// 剹hc		1.0, 10.0/9.0,5.0/4.0,4.0/3.0,3.0/2.0/*25.0/16.0*/,5.0/3.0,15.0/8.0
// 剹ɂƁ
		1.0, 9.0/8.0 , 6.0/5.0,4.0/3.0 , 3.0/2.0,8.0/5.0 ,9.0/5.0/* 3/2* 5/4 */
} ;
const float minorChangeTable_S[] = {
//		C#,D#=(B*6/5)/2,E#=F,F#,G#,A#,B#=C2
//		G#=G#Ȃ̂͌ܐŁiʏjtŕ\L邩
//		16.0/15.0,(9.0/4.0)/2.0,4.0/3.0,25.0/18.0,25.0/16.0/*5.0/3.0*/,9.0/5.0,2.0
//		C#,D#=(B*6/5)/2,E#=F,F#,G#,A#,B#=C2
//		A#,B#=C,C#,D#,E#=F,F#,G#
		10.0/9.0,6.0/5.0,  5.0/4.0, 27.0/20.0, 8.0/5.0, 5.0/3.0,15.0/8.0

} ;
double baseFreq = 440.0 ;
double tonicFreq ; //剹
// x8Ă̂PSGDutyCycleW̃Tvlō\Ă邽߁B
double KeyFreqs[7] = {
	/*440.0*/3.0/5.0	*8.0, // ñh̎gA(440.0Hz)狁߂
	/*440.0*/2.0/3.0	*8.0,
	/*440.0*/1.0/4.0*3.0		*8.0, // zA(440.0Hz)͎gĂȂ110.0Hz(QIN^[uAĵR{(E)gĂ݂
	/*440.0*/4.0/5.0	*8.0,
	/*440.0*/8.0/9.0	*8.0,
	/*440.0*/			8.0,
//̎ɂȂ	(440.0*)1.0/4.0*3.0*2.0	*3.0/4.0	*8.0
	/*440.0*/9.0/8.0	*8.0
};
STR_SOUND ss[DEF_SOUND_NUM] ;
int modulation = DEF_MOD_EQUAL ;
void soundInit(STR_SCALES &scaleInfo) {
	soundEnable() ;
	for( int i= 0 ; i < DEF_SOUND_NUM ; i++ ) {
		ss[i].mode = enum_ano_sound_mode_free ;
		ss[i].id = - 1;
		ss[i].vol = 96 ;
		ss[i].isChord = false ;
		ss[i].id = soundPlayPSG(DutyCycle_50, 1, ss[i].vol, 64);
	}
	for( int i= 0 ; i < DEF_SOUND_NUM ; i++ ) {
		soundPause(ss[i].id) ;
	}
	workFreq_n = new int[DEF_FREQ_NUM] ;
	workFreq_s = new int[DEF_FREQ_NUM] ;
	scaleInfo.ajust = 0 ;
	scaleInfo.mod = DEF_MOD_EQUAL ;
	scaleInfo.minor_mod = DEF_MOD_MINOR_H ;
	scaleInfo.key = 0 ;
	makeTonic(scaleInfo,true) ;
	makeFreq(scaleInfo) ;
}
//A=440+Hz剹쐬
double makeTonic(STR_SCALES &scaleInfo,bool isAjustBase) {
	double ret ;
	if( isAjustBase ) {
		baseFreq = 440.0+scaleInfo.ajust ;
		tonicFreq = baseFreq*KeyFreqs[scaleInfo.key] ;
		ret = tonicFreq - (440.0*KeyFreqs[scaleInfo.key]);
	}
	else {
		tonicFreq = (440.0*KeyFreqs[scaleInfo.key])+scaleInfo.ajust ;
		baseFreq = tonicFreq/KeyFreqs[scaleInfo.key] ;
		ret = baseFreq - 440.0;
	}
	return ret ;
}
//K̎g쐬
void makeFreq(STR_SCALES &scaleInfo) {
	int max = DEF_FREQ_NUM;
	int key = scaleInfo.key ;
	switch( scaleInfo.mod ) {
	case DEF_MOD_MEJOR :
		for( int o = 0 ; o < 4 ; o++ ) {
			
			for( int n = 0 ; n < 7 ; n++ ) {
				if( max <= (o*7+n+key) ) break ;
				workFreq_n[o*7+n+key] =(tonicFreq*((o<=1)?(o+1)/2.0:((o-1)*2.0)))*mejorChangeTable[n] ;
				workFreq_s[o*7+n+key] =(tonicFreq*((o<=1)?(o+1)/2.0:((o-1)*2.0)))*mejorChangeTable_S[n] ;
			}
		}
		for( int n = 0 ; n < 7 ; n++ ) {
			if( n < key ) workFreq_n[(0*7)+n] = workFreq_n[(1*7)+n]/2 ;
			if( n < key ) workFreq_s[(0*7)+n] = workFreq_s[(1*7)+n]/2 ;
		}
		break ;
	case DEF_MOD_MINOR:
		for( int o = 0 ; o < 4 ; o++ ) {
			
			for( int n = 0 ; n < 7 ; n++ ) {
				if( max <= (o*7+n+key) ) break ;
				workFreq_n[o*7+n+key] =(tonicFreq*((o<=1)?(o+1)/2.0:((o-1)*2.0)))*minorChangeTable[n] ;
				workFreq_s[o*7+n+key] =(tonicFreq*((o<=1)?(o+1)/2.0:((o-1)*2.0)))*minorChangeTable_S[n] ;
	
			}
		}
		for( int n = 0 ; n < 7 ; n++ ) {
			if( n < key ) workFreq_n[(0*7)+n] = workFreq_n[(1*7)+n]/2 ;
			if( n < key ) workFreq_s[(0*7)+n] = workFreq_s[(1*7)+n]/2 ;
		}
		for( int o = -1 ; o < 3 ; o++ ) {
			if( (o*7+key+6) < 0 ) continue ;
			if( max <= (o*7+5+key) ) break ; 
			switch( scaleInfo.minor_mod ) {
			case DEF_MOD_MINOR_M : // fa -> fa#
				if( 0 <= (o*7)+5+key ) workFreq_n[(o*7)+5+key] = workFreq_s[(o*7)+5+key] ;
//				break ;
			case DEF_MOD_MINOR_H : // so -> so#
				if( (o*7)+6+key < max ) workFreq_n[(o*7)+6+key] = workFreq_s[(o*7)+6+key] ;
			}
		}
		break ;
	default :
		for( int o = 0 ; o < 4 ; o++ ) {
			for( int n = 0 ; n < 7 ; n++ ) {
				if( max <= (o*7+n) ) break ;
				workFreq_n[o*7+n] =(baseFreq*((o<=1)?(o+1)/2.0:((o-1)*2.0)))*equalChangeTable[n] ;
				workFreq_s[o*7+n] =(baseFreq*((o<=1)?(o+1)/2.0:((o-1)*2.0)))*equalChangeTable_S[n] ;
			}
		}
		break ;
	}
}
//A=440+@̉o
void ajustSound(double ajust,bool isOn) {
	int onSs = -1 ;
	int freeSs = -1 ;
	for( int i = 0 ; i < DEF_SOUND_NUM ; i++ ) {
		if( ss[i].mode == enum_ano_sound_ajust ) onSs = i ;
		if( ss[i].mode == enum_ano_sound_mode_free ) {
			freeSs = i ;
		}
	}
	if( isOn ) {
		double freq ;
		freq = (440.0+ajust) * 8.0 ;
		if( onSs != -1 ) {
			soundSetFreq(ss[onSs].id,freq) ;
		}
		else if( freeSs != -1 ) {
				soundSetFreq(ss[freeSs].id,freq) ;
				soundSetVolume(ss[freeSs].id,96) ;
				soundResume(ss[freeSs].id) ;
				ss[freeSs].mode = enum_ano_sound_ajust ;
		}
	}
	else {
		if( -1 != onSs ) {
			ss[onSs].mode = enum_ano_sound_mode_free ;
			soundPause(ss[onSs].id) ;
		}
	}
}
//^b`yŉꂽꏊɂĉ
int pointSound(int x,int y,uint32 keys[3]) {
//printf("point sound start\n") ;
//if( x == 0 && y == 0 ) return -1 ;
	int note ;
	int onSs ;
	int chord[3] ;
	bool bChord ;
	int freeSs ;
//	int fpx = x*12/256 ;
//	int fpy = y*3/192 ;
//	int fp = (2-fpy)*12+fpx;
//	int fp = x*21/256 ;
//	int dp = y*7/192 ;
	int fp = x*7/256 ;
	int opt ;
	int basenote ;
	int i ;
	const int *useFreq_w ;
	basenote = 7 ;
	if( keys[2] & KEY_L ||
		keys[2] & KEY_LEFT) basenote -=7 ;
	if( keys[2] & KEY_R ||
		keys[2] & KEY_RIGHT) basenote +=7 ;
	useFreq_w = workFreq_n ;
	opt = DEF_NOTE_OPT_N ;
	bChord = false;
	if( y < 50 ) {	// 
		useFreq_w = workFreq_s ;
		opt = DEF_NOTE_OPT_S ;
	}
	if( (192-50) < y ) { // a
		bChord = true ;
	}
//	iprintf("SoundID note  basenote %d keys[2] 0x%x \n",basenote,keys[2]);
		chord[0] = -1 ;
		chord[1] = -1 ;
		chord[2] = -1 ;
	onSs = -1 ;
	freeSs = -1 ;
	note = -1 ;
	// ̉𒲂ׂ
	for( i = 0 ; i < DEF_SOUND_NUM ; i++ ) {
		if( ss[i].mode == enum_ano_sound_mode_on ) {
			onSs = i ;
			/* */
			if( ss[i].isChord ) {
				for( int c = 0 ; c < 3 ; c++ ) {
					if( chord[c] == -1 ) {
						chord[c] = i ;
						break ;
					}
				}
				bChord = true ; //a͘a[h
			}
			/* */
		}
	}
	// `l𒲂ׂ
	for( i = 0 ; i < DEF_SOUND_NUM ; i++ ) {
		if( ss[i].mode == enum_ano_sound_mode_free ) {
			freeSs = i ;
			if( bChord ) {
				for( int c = 0 ; c < 3 ; c++ ) {
					if( chord[c] == -1 ) {
						chord[c] = i ;
						ss[chord[c]].vol = 64 ;
						break ;
					}
				}
			}
		}
	}
	if( onSs == -1 && bChord ) { //apɂR`l󂯂
		int freenum ;
		freenum = 0 ;
		for( i = 0 ; i < DEF_SOUND_NUM ; i++ ) {
			if( ss[i].mode == enum_ano_sound_mode_free ) freenum++ ;
		}
		if( freenum < 3 ) {
			for( i = 0 ; i < DEF_SOUND_NUM ; i++ ) {
				if( ss[i].isChord ) {
					ss[i].mode = enum_ano_sound_mode_free ;
					ss[i].vol = 96 ;
	//				soundPause(ss[i].id) ;
					ss[i].isChord = false ;
				}
			}
		}
	}
	if( x != 0 && y != 0) { // ^b`Ă
		note = basenote + fp ;
		if( onSs != -1 ) {
			if( bChord) {
				for( int c = 0 ; c < 3 ; c++ ) {
					if( chord[c] != -1 ) {
						soundSetFreq(ss[chord[c]].id,useFreq_w[note+c*2]) ;
					}
				}
			}
			else {
				soundSetFreq(ss[onSs].id,useFreq_w[note]) ;
			}
		}
		else if( freeSs != -1 ) {
			if( bChord) {
				for( int c = 0 ; c < 3 ; c++ ) {
					if( chord[c] != -1 ) {
						soundSetFreq(ss[chord[c]].id,useFreq_w[note+c*2]) ;
						soundSetVolume(ss[chord[c]].id,ss[chord[c]].vol) ;
						soundResume(ss[chord[c]].id) ;
						ss[chord[c]].mode = enum_ano_sound_mode_on ;
						ss[chord[c]].isChord = true ;
					}
				}
//printf(" [%d] n[%d] v[%d]\n",ss[0].id,ss[1].id,ss[2].id) ;
			}
			else {
				soundSetFreq(ss[freeSs].id,useFreq_w[note]) ;
				soundSetVolume(ss[freeSs].id,ss[freeSs].vol) ;
				soundResume(ss[freeSs].id) ;
				ss[freeSs].mode = enum_ano_sound_mode_on ;
//printf(" [%d] n[%d] v[%d]\n",freeSs,note,ss[freeSs].vol) ;
			}
			
		}
//			iprintf("SoundID %04i\n", soundID);
	}
	else {	// ToutchPenĂ鎞̏
		if( onSs != -1 ) {
			for( i = 0 ; i < DEF_SOUND_NUM ; i++ ) {
				if( ss[i].mode == enum_ano_sound_mode_on ) ss[i].mode = enum_ano_sound_mode_off ;
			}
//			ss[onSs].mode = 0 ;
		}
	}
	for( i = 0 ; i < DEF_SOUND_NUM ; i++ ) {
		if( ss[i].mode == enum_ano_sound_mode_off ) { //@off[h̃`l̉ʂi
//			iprintf("SoundID volume[%d]  %d\n",i,ss[i].vol);
			ss[i].vol -= (ss[i].isChord)?4:6;
			if( ss[i].vol < 16 ) { // ʂPUɂȂΉ~߂
//					soundKill(ss[i].id) ;
				soundPause(ss[i].id) ;
				ss[i].mode = enum_ano_sound_mode_free ;
				ss[i].vol = 96 ;
				ss[i].isChord = false ;
//				ss[i].id = -1 ;
			}
			soundSetVolume(ss[i].id,ss[i].vol) ;
		}
		if( ss[i].mode == enum_ano_sound_mode_free ) {
			soundPause(ss[i].id) ;
		}
	}
//printf("point sound start\n") ;
	return note | opt ;
}
