
#include "ano_sprite.h"
#include <string.h>

const u16 l_sliderbuf[] = {
	0x0101,0x0101,0x0101,0x0101,0x0001,0x0000,0x0000,0x0200,
	0x0001,0x0000,0x0000,0x0200,0x0001,0x0000,0x0000,0x0200,
	0x0001,0x0000,0x0000,0x0200,0x0001,0x0000,0x0000,0x0200,
	0x0001,0x0000,0x0000,0x0200,0x0001,0x0000,0x0000,0x0200,

	0x0101,0x0101,0x0101,0x0001,0x0000,0x0000,0x0000,0x0001,
	0x0000,0x0000,0x0000,0x0001,0x0000,0x0000,0x0000,0x0001,
	0x0000,0x0000,0x0000,0x0001,0x0000,0x0000,0x0000,0x0001,
	0x0000,0x0000,0x0000,0x0001,0x0000,0x0000,0x0000,0x0001,

	0x0001,0x0000,0x0000,0x0200,0x0001,0x0000,0x0000,0x0200,
	0x0001,0x0000,0x0000,0x0200,0x0001,0x0000,0x0000,0x0200,
	0x0001,0x0000,0x0000,0x0200,0x0001,0x0000,0x0000,0x0200,
	0x0001,0x0000,0x0000,0x0200,0x0101,0x0101,0x0101,0x0101,
	
	0x0000,0x0000,0x0000,0x0001,0x0000,0x0000,0x0000,0x0001,
	0x0000,0x0000,0x0000,0x0001,0x0000,0x0000,0x0000,0x0001,
	0x0000,0x0000,0x0000,0x0001,0x0000,0x0000,0x0000,0x0001,
	0x0000,0x0000,0x0000,0x0001,0x0101,0x0101,0x0101,0x0001,
} ;
void initSprite() {
	oamInit(&oamMain,SpriteMapping_1D_32,false) ;
	oamInit(&oamSub,SpriteMapping_1D_32,false) ;
	u16* gfx = oamAllocateGfx(&oamMain, SpriteSize_32x16, SpriteColorFormat_256Color);
	u16* gfxSub = oamAllocateGfx(&oamSub, SpriteSize_16x16, SpriteColorFormat_256Color);
	SPRITE_PALETTE[1] = ARGB16(1,24,24,24);
	SPRITE_PALETTE_SUB[1] = ARGB16(1,0,31,0);
	SPRITE_PALETTE_SUB[2] = ARGB16(1,24,0,0);
	oamClear(&oamMain,0,128) ;
	oamClear(&oamSub,0,128) ;
	memcpy(gfxSub,l_sliderbuf,sizeof(l_sliderbuf)) ;
	for( int i = 0 ; i < 32*16/2 ; i++ ) {
		gfx[i] = 1|(1<<8) ;
	}
}
void dispNote(int note,int *xpos) {
	u16 *gfx = oamGetGfxPtr(&oamMain,0) ;
	int pw = (note & DEF_NOTE_NUM)%7 ;
	
	if( (note&DEF_NOTE_NUM) == DEF_NOTE_NUM ) {
		oamSet(&oamMain, 
			0,0, 0, 0, 0,
			SpriteSize_32x16, 
			SpriteColorFormat_256Color, 
			gfx, 
			-1, 
			false, 
			true);
		return ;
	}
	int add ;
	if( (note&DEF_NOTE_OPT) == DEF_NOTE_OPT_S ) {
		add = 16 ;
		SPRITE_PALETTE[1] = ARGB16(1,31,10,10);
	}
	else {
		add = 2 ;
		SPRITE_PALETTE[1] = ARGB16(1,24,24,24);
	}
	oamSet(&oamMain, 
		0,xpos[pw]+add, 180, 0, 0,
		SpriteSize_32x16, 
		SpriteColorFormat_256Color, 
		gfx, 
		-1, 
		false, 
		false);
}
bool dispSlider(uint32 *keys,int x,int y,STR_SCALES &scaleInfo,bool isBeforeAjust) {
	u16 *gfxSub = oamGetGfxPtr(&oamSub,0) ;
	if( keys == NULL ) {
		oamSet(&oamSub, 
			0, 
			0, 
			0, 
			0, 
			0,
			SpriteSize_16x16, 
			SpriteColorFormat_256Color, 
			gfxSub, 
			-1, 
			false, 
			true);
		ajustSound(scaleInfo.ajust,false) ;
		return false;
	}
	oamSet(&oamSub, 
		0, 
		scaleInfo.ajust*16+128-8, 
		49, 
		0, 
		0,
		SpriteSize_16x16, 
		SpriteColorFormat_256Color, 
		gfxSub, 
		-1, 
		false, 
		false);
	if( ! (keys[2] & KEY_TOUCH) ) {
		ajustSound(scaleInfo.ajust,false) ;
		return false;
	}
	if( ! isBeforeAjust ) {
		if( y < 48 || 64 < y ) {
			ajustSound(scaleInfo.ajust,false) ;
			return false;
		}
	}
	int w = (x) / 16 ;
	int wa = (x) % 16 ;
//	w += (wa < 5 )?-1:0 ;
	w += (13 <= wa )?1:0 ;
//	if( 128 < x ) {
		if( 3 <= wa && wa < 13 ) {
			scaleInfo.ajust = (x-128) / 16.0  ;
		}
		else scaleInfo.ajust = w - 128/16;
		/*
	}
	else {
		if( -3 <= wa && wa < -13 ) {
			scaleInfo.ajust = (x-128) / 16.0  ;
		}
		else scaleInfo.ajust = w ;
	}
	*/
	oamSet(&oamSub, 
		0, 
		scaleInfo.ajust*16+128-8, 
		49, 
		0, 
		0,
		SpriteSize_16x16, 
		SpriteColorFormat_256Color, 
		gfxSub, 
		-1, 
		false, 
		false);
	ajustSound(scaleInfo.ajust,true) ;
	return true ;
}
