/*---------------------------------------------------------------------------------

	Simple console print demo
	-- dovoto

---------------------------------------------------------------------------------*/
#include <nds.h>
#include <stdio.h>
#include <fat.h>
//#include <list>
#include "disp2D.h"
#include "ano_sound.h"
#include "ano_draw.h"
#include "ano_sprite.h"

#include "3d.h"
#include "ano.h"
int l_mode = enum_play ;
int l_submode = enum_sub_play ;

//[h`
void mode_op(uint32 keys[3],STR_SCALES &scaleInfo) {
	// main mode
	if( keys[0] & KEY_SELECT ) {
		consoleClear() ;
		l_mode++ ;
		if( l_mode == enum_end ) l_mode = enum_play ;
	}
	if( l_mode != enum_console_off ) {
		iprintf("\x1b[0;1H :play");
		iprintf("\x1b[1;1H :camera");
		iprintf("\x1b[2;1H :obj");
		iprintf("\x1b[3;1H mode cheange [select]");
	}
	switch(l_mode) {
	case enum_play :
		iprintf("\x1b[0;0H*");
		break ;
	case enum_camera :
		iprintf("\x1b[1;0H*");
		break ;
	case enum_obj :
		iprintf("\x1b[2;0H*");
		break ;
	}
	// sub mode
	l_submode = enum_sub_play ;
	if( l_mode == enum_play || l_mode == enum_console_off ) {
		if( keys[2] & KEY_DOWN ) {
			l_submode = enum_sub_modulation_change_key ;
		}
		if( l_mode != enum_console_off ) {
			iprintf("\x1b[15;0H temperament  ") ;
			iprintf("\x1b[14;19H minor mode  ") ;
			iprintf("\x1b[17;0H equal ") ;
			iprintf("\x1b[19;0H just (mejor)") ;
			iprintf("\x1b[21;0H just (minor)") ;
			iprintf("\x1b[17;18H              ") ;
			iprintf("\x1b[15;18H              ") ;
			if( scaleInfo.minor_mod == DEF_MOD_MINOR_N ) {
				iprintf("\x1b[17;18Hnatulal") ;
				iprintf("\x1b[15;22Hharmonic") ;
				iprintf("\x1b[15;25Hmelodic") ;
			}
			else if( scaleInfo.minor_mod == DEF_MOD_MINOR_H ) {
				iprintf("\x1b[15;18Hnatulal") ;
				iprintf("\x1b[17;22Hharmonic") ;
				iprintf("\x1b[15;25Hmelodic") ;
			}
			else {
				iprintf("\x1b[15;18Hnatulal") ;
				iprintf("\x1b[15;22Hharmonic") ;
				iprintf("\x1b[17;25Hmelodic") ;
			}
//	printf("   %s %s  ",m_keys[key],m_mods[mod]) ;
		}
	}
}
//ύX^`[jOʍ쐬
void modulationChangeInit(disp2D_BMP16 &disp,int *xpos,int *ypos,STR_SCALES &scaleInfo) {
	// frame
	disp.fill(0,0,255,64,ARGB16(1,0,0,0)) ;
	disp.box(0,0,255,ypos[3],ARGB16(1,31,31,20)) ;
	for( int x = 1 ; x <7 ; x++ ) {
		disp.line(xpos[x],16,xpos[x],ypos[3],ARGB16(1,31,31,20)) ;
	}
	for( int x = 4 ; x <7 ; x++ ) {
		disp.line(xpos[x],0,xpos[x],ypos[3],ARGB16(1,31,31,20)) ;
	}
	for( int y = 1 ; y <3 ; y++ ) {
		disp.line(0,ypos[y],256,ypos[y],ARGB16(1,31,31,20)) ;
	}
	// state
	switch(scaleInfo.mod) {
	case DEF_MOD_MEJOR :
		disp.fill(xpos[scaleInfo.key]+1,ypos[1]+1,xpos[scaleInfo.key+1]-1,ypos[2]-1,ARGB16(1,24,6,7)) ;
	break ;
	case DEF_MOD_MINOR :
		disp.fill(xpos[scaleInfo.key]+1,ypos[2]+1,xpos[scaleInfo.key+1]-1,ypos[3]-1,ARGB16(1,7,6,24)) ;
	break ;
	default :
		disp.fill(xpos[0]+1,1,xpos[4]-1,ypos[1]-1,ARGB16(1,7,31,7)) ;
		break ;
	}
	switch(scaleInfo.minor_mod) {
	case DEF_MOD_MINOR_N :
		disp.fill(xpos[4]+1,ypos[0]+1,xpos[4+1]-1,ypos[1]-1,ARGB16(1,7,6,24)) ;
		break ;
	case DEF_MOD_MINOR_H :
		disp.fill(xpos[5]+1,ypos[0]+1,xpos[5+1]-1,ypos[1]-1,ARGB16(1,7,6,24)) ;
		break ;
	case DEF_MOD_MINOR_M :
		disp.fill(xpos[6]+1,ypos[0]+1,xpos[6+1]-1,ypos[1]-1,ARGB16(1,7,6,24)) ;
		break ;
	break ;
	}
	//tonic ajust
	disp.line(0,56,256,56,ARGB16(1,10,10,10),2) ;
	u16 c ;
	for( int x = 0 ; x <= 256 ; x += 16 ) {
		if( x == 128 ) c = ARGB16(1,10,10,31) ;
		else c = ARGB16(1,10,10,10);
		disp.line(x-2,49,x-2,64,c,3) ;
	}
}
//ύX^`[jOʍ쐬
void modulationChangeKey(disp2D_BMP16 &disp,int *xpos,int *ypos,int x,int y,STR_SCALES &scaleInfo) {
	int mod ;
	mod = -1 ;

	if( y < ypos[1] ) {
		if( x < xpos[4] ) mod = DEF_MOD_EQUAL ;
		else {
			if( x < xpos[5] ) scaleInfo.minor_mod = DEF_MOD_MINOR_N ;
			else if( x < xpos[6] ) scaleInfo.minor_mod = DEF_MOD_MINOR_H ;
			else  scaleInfo.minor_mod = DEF_MOD_MINOR_M ;
		}
	}
	else if( y < ypos[2] ) mod = DEF_MOD_MEJOR ;
	else if( y < ypos[3] ) mod = DEF_MOD_MINOR ;
	if( mod != -1 ) {
		int key = x*7/256 ;
		scaleInfo.mod = mod ;
		scaleInfo.key = key ;
	}
//	printf("mod[%d] key[%d]\n",mod,key) ;
	makeTonic(scaleInfo,true) ;
	makeFreq(scaleInfo) ;
	modulationChangeInit(disp,xpos,ypos,scaleInfo) ;
/*
	if( DEF_MOD_EQUAL == mod ) key = 7 ;
	iprintf("\x1b[%d;0H",18+mod*2) ;
	printf("   %s %s  ",m_keys[key],m_mods[mod]) ;
	*/
}
//---------------------------------------------------------------------------------
int main(void) {
	int bgmain ;
	int bgsub ;
//---------------------------------------------------------------------------------
	touchPosition touch;
	videoSetMode(MODE_5_3D| 
		DISPLAY_SPR_ACTIVE|DISPLAY_SPR_1D|	// sprite on
		DISPLAY_BG0_ACTIVE|					// for 3D
		DISPLAY_BG1_ACTIVE|					// for console
		DISPLAY_BG2_ACTIVE);				// for 2D Bitmap
	videoSetModeSub(MODE_5_2D|
		DISPLAY_SPR_ACTIVE|DISPLAY_SPR_1D|	// sprite on
		DISPLAY_BG3_ACTIVE); 				// for 2D Bitmap
//vram
//A 128k
//B 128k
//C 128k
//D 128k
//E 64k
//F 16k
//G 16k
//H 32k
//I 16k
	vramSetBankA(VRAM_A_LCD); // for DISPCAPCNT
	vramSetBankB(VRAM_B_TEXTURE);// for 3D texture
	vramSetBankC(VRAM_C_SUB_BG);// for SUB BG
	vramSetBankD(VRAM_D_MAIN_BG_0x06060000);//for MAIN BG
	vramSetBankE(VRAM_E_MAIN_BG) ; //for MAIN console
	vramSetBankF(VRAM_F_MAIN_BG_0x06010000) ;//for MAIN console
	vramSetBankG(VRAM_G_MAIN_SPRITE) ;// for MAIN SPRITE
//	vramSetBankH(VRAM_H_SUB_BG_EXT_PALETTE) ;
	vramSetBankI(VRAM_I_SUB_SPRITE) ; // for SUB SPRITE
	
	// MAIN BG2 = Bitmap	mapbase24 -> 0x06060000 -> VRAM_D
	bgmain = bgInit(2,BgType_Bmp16,BgSize_B16_256x256,24,0) ;
	// SUB  BG3 = Bitmap	mapbase 0(sub) -> 0x06200000 -> VRAM_C
	bgsub = bgInitSub(3,BgType_Bmp16,BgSize_B16_256x256,0,0) ;

	// MAIN BG1 = console	mapbase 0 -> 0x06000000 -> VRAM_E
	bgInit(1,BgType_Text4bpp,BgSize_T_256x256,BG_MAP_BASE(0),BG_TILE_BASE(1)) ;
	PrintConsole topScreen = *consoleInit(0, 1,BgType_Text4bpp, BgSize_T_256x256, BG_MAP_BASE(0),BG_TILE_BASE(1), true);
	consoleClear() ;

	// libfat initialize
	if (! fatInitDefault()) {
	   // Initialization of libfat failed.
		iprintf("libfat initialize failed\n");
	}

	init3D(true) ;

	// 2D`pNX쐬
	disp2D_BMP16 disp ;					// MAIN BGp
	disp2D_BMP16 disp_sub ;				// SUB  BGp
	disp2D_BMP16 disp_sub2(256,64) ;	// ύX^`[jOʁij

	disp.set2D((u16*)BG_BMP_RAM(24)) ;

	disp_sub.set2D((u16*)BG_BMP_RAM_SUB(0)) ;
	disp_sub.makeBack() ;

	u16 *disp_sub2mem = new u16[256*64] ;
	disp_sub2.set2D(disp_sub2mem) ;
//	disp_sub.box(0,0,255,191,RGB15(31,12,0)|0x8000,4) ;
//	disp.fill(100,50,146,90,RGB15(31,31,31)|0x8000) ;
//	disp.line(250,50,20,90,RGB15(0,15,20)|0x8000) ;
//	disp_sub2.fill(0,0,255,64,RGB15(31,31,31)|0x8000) ;

	int xx;
	xx = 0 ;
	int xpos[8] ;
	int ypos[4] ;
	int ypos2[4] ;
	int pw ;
	pw = 1 ;
	xpos[0] = 0 ;
	xpos[7] = 256 ;
	ypos[0] = 0 ;
	ypos[1] = 50 ;
	ypos[2] = 192-50 ;
	ypos[3] = 192 ;
	ypos2[0] = 0 ;
	ypos2[1] = 16 ;
	ypos2[2] = 32 ;
	ypos2[3] = 48 ;

	// 256(TCY)h`VŕƂ̍W߂
	for( int x = 1 ; x < 256 ; x++ ) {
		if( xx == x*7/256 ) continue ;
		xx = x*7/256 ;
		xpos[pw++] = x ;
//		disp.line(x,180,x,191,ARGB16(1,0,15,20)) ;
	}

	STR_SCALES scaleInfo ;
	soundInit(scaleInfo) ;
	initSprite() ;
	drawInit() ;

	modulationChangeInit(disp_sub2,xpos,ypos2,scaleInfo) ;

	
//	int soundID = -1 ;
uint32   keys[3];
uint32   keysDmy[3];
int note ;
int beforenote ;
beforenote = -1 ;
int counter ;
counter = 0 ;
bool sublineTgle ;
sublineTgle = false ;
bool effectTgle ;
effectTgle = false ;
bool isAjust ;
isAjust = false ;
u16 *img ;
	keysDmy[0] = 0 ;
	keysDmy[1] = 0 ;
	keysDmy[2] = 0 ;
	consoleClear() ;
	// [v
	while(1) {
		// L[͎o
		scanKeys()  ;
		keys[0] = keysDown() ;
		keys[1] = keysUp() ;
		keys[2] = keysHeld() ;
		touchRead(&touch);

		//@[h`揈
		mode_op(keys,scaleInfo) ;

		disp_sub.getBack() ;
//printf("counter = %d\n",counter) ;
		if( counter==0) {
			if( effectTgle ) disp_sub.alphaBack() ;
			else disp_sub.clearBack(ARGB16(1,0,0,0)) ;
			if( sublineTgle ) drawSubLine(disp_sub,xpos,ypos,8,4) ;
		}
		if( l_submode == enum_sub_modulation_change_key ) {
			// ύXE`[jO[h
			// Tuʂ̕\ʒuɂ炷
			disp_sub.setOffset(64) ;
			// TuʂɉύX^`[jOʂ\
			disp_sub.flushMem(disp_sub2.get2D(),0,64) ;
			// `[jOpXC_[̕\
			bool before = isAjust ;
			isAjust = dispSlider(keys,touch.px,touch.py,scaleInfo,isAjust) ;
			if( ! isAjust ) {
				if( keys[0] & KEY_TOUCH) {
					modulationChangeKey(disp_sub2,xpos,ypos2,touch.px,touch.py,scaleInfo) ;
				}
				else {
					if( before ) {
						makeTonic(scaleInfo,true) ;
						makeFreq(scaleInfo) ;
					}
				}
			}
			// ύXE`[jO[h̎̓Rȍ~̏Ń^b`y͖̓͂Ƃ
			memset(&touch,0,sizeof(touch)) ;
		}
		else {
			// ύXE`[jO[h ȊO
			if( isAjust ) {//O܂Ń`[jOĂH
				//`[jOʂɔf
				isAjust= false ;
				makeTonic(scaleInfo,true) ;
				makeFreq(scaleInfo) ;
			}
			// `[jOpXC_[XvCg
			dispSlider(NULL,0,0,scaleInfo,isAjust) ;
			// Tuʂ̕\ʒuɖ߂
			disp_sub.setOffset(0) ;
		}
#if DEF_EMU
		// ȂH@DeSmuMEł̃rbgėBBBfobO߂ǂ̂Ńrbg𗎂Ƃ
		keys[2] = keys[2] & 0xe3ff ; // for DeSmuME
#endif
		// [A]L[ŕ⏕\On/Off
		if( keys[0] & KEY_A ) sublineTgle = ! sublineTgle ;
		// [B]L[ŕ\GtFNgOn/Off
		if( l_mode == enum_play ) {
			if( keys[0] & KEY_B ) effectTgle = ! effectTgle ;
			iprintf("\x1b[0;16Heffect[B] %s  ",(effectTgle)?"On ":"Off") ;
		}

		// ^b`ʒuŉo
		note = pointSound(touch.px,touch.py,keys) ;
		// ^b`ʒuŕ`o
		pointDraw(touch.px,touch.py,disp_sub,keys,note,counter==0) ;
		// SUBʂ̉摜oi3D\ɎgpiJjj
		img = disp_sub.get2DBack() ;
		disp_sub.flushBack() ;
		
		// 3Df\
		drow3D(l_mode,keys,img,note) ;
#if DEF_Flickr
		// 3Df̂ጸB
		// ďƂۂǁA悤̓S}JV
		// 3D\VRAM_AɃRs[
		REG_DISPCAPCNT=
			DCAP_A(0)|
			DCAP_B(0)|
			DCAP_BANK(0)|
			DCAP_OFFSET(0)|
			DCAP_SIZE(3)|
			DCAP_SRC(1)|
			DCAP_DST(0)|
			DCAP_MODE(0)|
			DCAP_ENABLE;
		//vsynk wait
		swiWaitForVBlank();
		oamUpdate(&oamSub);
		oamUpdate(&oamMain);
		//Rs[҂
		while(REG_DISPCAPCNT & DCAP_ENABLE);
//		disp_sub.flushMem((u16*)BG_BMP_RAM(8)) ;
		//Rs[摜MAIN BGɃRs[
		//3D摜ĂɓĜŖڗȂĐ@
		disp.flushMem((u16*)VRAM_A) ;
#endif
		//@ύX^`[jO[hȊO
		//@ύX^`[jOʂMAIN BGɕ`悷
		if( l_submode == enum_sub_play ) {
			if( l_mode != enum_console_off ) {
				u16 *img2 ;
				img2 = disp_sub2.get2D() ;
				img = disp.get2D() ;
				dmaCopy(img2,&img[256*(192-60)],256*56*2) ;
			}
		}
		//  oɑΉꏊsprite\iMAINʁj
		dispNote(note,xpos) ;
		//  vsync JE^
		counter++ ;
		counter &= 0x01 ;

#if DEF_Flickr
#else
		swiWaitForVBlank();
		oamUpdate(&oamSub);
		oamUpdate(&oamMain);
#endif
	}
	return 0;
}
